# 《The Book Of Ruby》 - Chinese Edition

本项目对开源书籍《The Book Of Ruby》进行了简体中文的翻译，目的：

1. 通过本书了解 Ruby 语言的细节和内部机制；
2. 作为留给自己和国内同样热爱 Ruby 的开发者的一份参考资料，中文版可以快速浏览和查阅；
3. 算是对开源社区做的一份小小贡献，正所谓 - 给予比接受更快乐！

## 在线浏览

https://wang1212.github.io/the-book-of-ruby/

## 关于本书

<div align="center">
  <img src="https://wang1212.github.io/the-book-of-ruby/images/book-of-ruby.jpg" />
</div>

书名：《The Book Of Ruby》

作者：How Collingbourne

页数：425 页

出版时间：2011-7-13

翻译完成时间：2019.01.13

简介：《The Book Of Ruby》是一本免费的 Ruby 编程高级教程。以 PDF 文件格式提供，并且每一个章节的所有例子都伴有可运行的源代码。同时，也有一个介绍来阐述如何在 Steel 或其它任何你喜欢的编辑器/IDE 中运行这些 Ruby 代码。它主要集中于 Ruby 语言的 1.8.x 版本。

目录概述：

- 第一章：字符串、数字、类和对象 - 获取输入和输出，字符串和内嵌表达式，数字和测试语句 if...then，局部变量和全局变量，类和对象，实例变量，消息、方法与多态性，构造方法与对象初始化，查看对象信息。
- 第二章：类的层次结构、属性与变量 - 超类与子类，访问器方法，属性读写，调用超类方法，类变量。
- 第三章：字符串和 Range - 字符串分隔符，字符串处理方法，Range，Range 迭代器。
- 第四章：数组与 Hash - 常用处理方法。
- 第五章：循环和迭代器 - for 循环，多参数迭代，代码块，while 循环，until 循环，loop 循环。
- 第六章：条件语句 - if...then...else，and...or...not，if...elsif，unless，case 语句，=== 方法，catch 与 throw。
- 第七章：方法 - 类方法，类变量，构造方法，单例方法，单例类，重写方法，public、private 和 protected 方法。
- 第八章：参数传递与返回值 - 实例方法，类方法，单例方法，返回值，返回多个值，默认参数和多参数，整数，进出原则，并行赋值，引用传值。
- 第九章：异常处理 - rescue，ensure，else，error 编号，retry，raise。
- 第十章：Block、Proc 和 Lambda - 匿名函数，proc 与 lambda，闭包，yield，嵌套块，优先级规则，块中实例变量，块中局部变量。
- 第十一章：符号 - 符号与字符串，符号和变量，为什么使用符号？
- 第十二章：模块和 mixin - 模块与类，模块方法，命名空间，包含模块，alias 方法，作用域解析符。
- 第十三章：文件与 IO - 打开和关闭文件，文件和目录，赋值文件，目录查询，递归，排序。
- 第十四章：Yaml - 转换成 yaml，嵌套序列，保存 yaml 数据，一个文件包含多个 yaml 文档，yaml 数据库。
- 第十五章：Marshal - 保存与加载数据，保存单例对象，yaml 与单例对象。
- 第十六章：正则表达式 - 匹配组，前后匹配，贪婪匹配，字符串方法，文件操作。
- 第十七章：线程 - 创建线程，运行线程，主线程，线程状态，线程优先级，主线程优先级，互斥。
- 第十八章：调试与测试 - irb、调试、单元测试、断言。
- 第十九章：Ruby On Rails - 安装 RoR、第一个 RoR 应用，创建控制器，创建视图，Rails 标记，MVC。
- 第二十章：动态编程 - 自修改程序，eval，动态添加变量和方法，运行时创建类，绑定，send，移除方法。

本书由 SapphireSteel Software 发布，SapphireSteel Software 是用于 Visual Studio 的 Ruby In Steel 集成开发环境的开发者。读者可以复制和发布本书的文本和代码（免费版）。

## 引用

如要引用该项目，请注明出处，谢谢！
